//
//  SelectDrugsViewController.m
//  DrugAlliance
//
//  Created by 李翩翩 on 2019/9/19.
//  Copyright © 2019 China. All rights reserved.
//

#import "SelectDrugsViewController.h"
#import "SelectDrugsTableViewCell.h"
#import "SelectDrugsModel.h"
#import "Constant.h"
#import <NSObject+MJKeyValue.h>

static NSString *const resueIdentifier = @"SelectDrugsTableViewCell";

@interface SelectDrugsViewController () <UITableViewDelegate,UITableViewDataSource,SelectDrugsTableViewCellDelegate>
@property (nonatomic,strong) NSMutableArray *  dataArr;
@property (nonatomic ,strong) NSMutableArray * listArray;
@property (nonatomic ,strong) NSMutableArray *tempArray;
@property (weak, nonatomic) IBOutlet UILabel *alldrugsLabel;
// 一键清除按钮
@property (nonatomic, strong) UIButton *clearButton;


@end

@implementation SelectDrugsViewController

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.translucent = NO;
    self.navigationController.navigationBar.backgroundColor = [UIColor whiteColor];
    
    self.navigationController.navigationBar.subviews[0].subviews[0].hidden = YES;
    self.navigationController.navigationBar.tintColor = [UIColor blackColor];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"药品列表";
    _tempArray = [NSMutableArray array];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    [self.navigationController.navigationBar setHidden:NO];
    
    self.selLabel.font = [Constant fit_configure:15.0];
    self.drugsLabels.font = [Constant fit_configure:15.0];
    self.druLabels.font = [Constant fit_configure:15.0];
    self.allLabel.font = [Constant fit_configure:14.0];
    self.pieceNumLabel.font = [Constant fit_configure:14.0];
    self.pieceLabel.font = [Constant fit_configure:14.0];
    self.selectButton.titleLabel.font = [Constant fit_configure:15.0];
    self.selectButton.layer.borderColor = [UIColor clearColor].CGColor;
    
    _listArray = [NSMutableArray array];
    
    [self.tableView registerNib:[UINib nibWithNibName:@"SelectDrugsTableViewCell" bundle:nil] forCellReuseIdentifier:@"SelectDrugsTableViewCell"];
    
    self.tableView.tableHeaderView = [[UIView alloc] initWithFrame:CGRectMake(0.0f, 0.0f, self.tableView.bounds.size.width, 0.01f)];
    
    if (self.navigationController != nil)
    {
        //push过来这个页面的时候
        _clearButton = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 80, 64)];
        [_clearButton setTitle:@"一键清除" forState:UIControlStateNormal];
        _clearButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
        [_clearButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
        _clearButton.titleLabel.font = [Constant fit_configure:14.0];
        [_clearButton addTarget:self action:@selector(clearAction) forControlEvents:UIControlEventTouchUpInside];
        _clearButton.hidden = YES;
        self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:_clearButton];
    }
    
}
#warning 一键清除 清空底部的数据
- (void) clearAction
{
    for (SelectDrugsModel  *drugsModel in _tempArray) {
        drugsModel.num = 0;
    }
     [_tempArray removeAllObjects];
    [self.tableView reloadData];
    self.drugsLabels.text = @"0";
    self.pieceNumLabel.text = @"0";
    self.alldrugsLabel.text = @"";
    self.selectButton.enabled = NO;
    self.selectButton.backgroundColor = [UIColor lightGrayColor];
    self.clearButton.hidden = YES;
}
- (void)drugsCellDidClickAddButtonAndCutButton:(SelectDrugsTableViewCell *)drugsCell addOrcut:(int)num
{
    //点击减号
    if (num==0) {
        if ([self.tempArray containsObject:drugsCell.drugsModel]) {
            if (drugsCell.drugsModel.num == 0) {
                [self.tempArray removeObject:drugsCell.drugsModel];
            }
        }
    } else {
        if (![self.tempArray containsObject:drugsCell.drugsModel]) {
            if (self.tempArray.count >= 5) {
                NSLog(@"最多增加五条!");
                drugsCell.drugsModel.num = 0;
            }else{
                [self.tempArray addObject:drugsCell.drugsModel];
            }
        }
    }
    [self.tableView reloadData];
    [self ClickBuyButton:0];
}

// 加号减号按钮调用的方法
- (void)ClickBuyButton:(NSInteger)allCount {
    allCount = 0;
    NSMutableArray *nameArray = [NSMutableArray array];
    NSMutableArray *nameListArray = [NSMutableArray array];
    for (int i = 0; i<self.tempArray.count; i++) {
        [nameArray addObject:[self.tempArray[i]valueForKey:@"name"]];
        nameListArray = [nameArray valueForKeyPath:@"@distinctUnionOfObjects.self"];
    }
    NSMutableArray *lastArray = [NSMutableArray array];
    NSMutableArray *result = [NSMutableArray array];
    for (SelectDrugsModel * drugsModel in _tempArray) {
        if (drugsModel.num) {
            allCount += drugsModel.num;
            [_listArray addObject:drugsModel.name];
            result = [_listArray valueForKeyPath:@"@distinctUnionOfObjects.self"];
            if ([result containsObject:drugsModel.name]) {
                [lastArray addObject:drugsModel];
            }
        }
    }
    self.selectButton.enabled = (_tempArray.count > 0)?YES:NO;
    _clearButton.hidden = (_tempArray.count > 0)?NO:YES;
    _selectButton.backgroundColor = (_tempArray.count > 0)?[Constant colorWithHexString:@"#3997fd"]:[UIColor lightGrayColor];
    self.drugsLabels.text = [NSString stringWithFormat:@"%ld",_tempArray.count];
    self.pieceNumLabel.text = [NSString stringWithFormat:@"%ld",allCount];
    self.alldrugsLabel.text = [nameListArray componentsJoinedByString:@","];
}
- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.dataArr.count;
}

- (UITableViewCell * )tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    SelectDrugsTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"SelectDrugsTableViewCell" forIndexPath:indexPath];
    if (!cell) {
        cell = [[SelectDrugsTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"SelectDrugsTableViewCell"];
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;//cell点击无效果
    cell.drugsModel = self.dataArr[indexPath.row];
    cell.delegate = self;
    return cell;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 100.0;
}
#pragma mark - 懒加载
- (NSMutableArray *)dataArr{
    if (!_dataArr) {
        _dataArr = [SelectDrugsModel mj_objectArrayWithFilename:@"drugs.plist"];
        for (int i = 0; i < _dataArr.count; i++) {
            [_dataArr[i] setValue:@(YES) forKey:@"addSate"];
        }
    }
    return _dataArr;
}
- (IBAction)theButtonWithSelect:(id)sender {
    if (_drugsInfo != nil) {
           _drugsInfo(self.tempArray,self.alldrugsLabel.text);
       }
       [self.navigationController popViewControllerAnimated:YES];
}
- (void)returnDrugsInfo:(DrugsBlock)block {
    _drugsInfo = block;
}
/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
